import java.io.IOException;

import org.junit.Test;
import org.polymodel.x10p.PolyhedralX10Analyzer;
import org.polymodel.x10p.analysis.DFAOutput;
import org.polymodel.x10p.analysis.DFAOutput.VERBOSITY;


public class MainClassTest {



	private static final String ROOT = "./x10src/";

	//sequential tests
	@Test
	public void dataflowEx001() {
		test("dataflowEx001.x10p");
	}
	@Test
	public void dataflowEx002() {
		test("dataflowEx002.x10p");
	}
	@Test
	public void dataflowEx003() {
		test("dataflowEx003.x10p");
	}

	//X10 with scalar only
	@Test
	public void dataflowEx101() {
		test("dataflowEx101.x10p");
	}
	@Test
	public void dataflowEx102() {
		test("dataflowEx102.x10p");
	}
	@Test
	public void dataflowEx103() {
		test("dataflowEx103.x10p");
	}
	

	@Test
	public void examplePaper1() {
		test("examplePaper1.x10p");
	}

	@Test
	public void examplePaper2() {
		test("examplePaper2.x10p");
	}

	@Test
	public void examplePaper3() {
		test("examplePaper3.x10p", true);
	}
	
	//Paul's
	@Test
	public void ex1() {
		test("ex1.x10p");
	}
	@Test
	public void ex3() {
		test("ex3.x10p");
	}
	@Test
	public void ex4() {
		test("ex4.x10p");
	}
	@Test
	public void ex5() {
		test("ex5.x10p");
	}
	@Test
	public void ex6() {
		test("ex6.x10p");
	}
	@Test
	public void ex8() {
		test("ex8.x10p");
	}
	@Test
	public void ex9() {
		test("ex9.x10p");
	}

	@Test
	public void ex10() {
		test("ex10.x10p");
	}
	
	@Test
	public void ex11() {
		test("ex11.x10p");
	}
	
	@Test
	public void ex12() {
		test("ex12.x10p");
	}
	
	@Test
	public void ex60() {
		test("ex60.x10p");
	}
	
	@Test
	public void ex61() {
		test("ex61.x10p");
	}
	
	@Test
	public void sanjay_01b() {
		test("sanjay-01b.x10p");
	}
	
	@Test
	public void matrix_transpose() {
		test("matrix_transpose.x10p");
	}
	
	@Test
	public void existentialEx1() {
		test("existentialEx1.x10p", true);
	}
	
	@Test
	public void jacobi1D() {
		test("jacobi1D.x10p");
	}
	
	@Test
	public void gauss2D() {
		test("gauss2D.x10p");
	}
	

	
	private void test(String file) {
		System.out.println(file +":\n");
		try {
			DFAOutput output = PolyhedralX10Analyzer.analyze(ROOT+file, true, false);

			System.out.println(output.toString(VERBOSITY.DEFAULT));
			System.out.println(output.printDFAResults());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	

	private void test(String file, boolean usejni) {
		System.out.println(file +":\n");
		try {
			DFAOutput output = PolyhedralX10Analyzer.analyze(ROOT+file, true, usejni);

			System.out.println(output.toString(VERBOSITY.DEFAULT));
			System.out.println(output.printDFAResults());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
